unit MDIEdit;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls, Buttons, Inference;

type

TEditForm = class(TForm)
    MainMenu1 : TMainMenu;
    File1 : TMenuItem; 
    New1 : TMenuItem;
    Open1 : TMenuItem;
    Save1 : TMenuItem; 
    Saveas1 : TMenuItem; 
    N2 : TMenuItem;
    Exit1 : TMenuItem; 
    Edit1 : TMenuItem;
    Cut1 : TMenuItem;
    Copy1 : TMenuItem;
    Paste1 : TMenuItem; 
    Delete1 : TMenuItem;
    N3 : TMenuItem;
    Selectall1 : TMenuItem; 
    PopupMenu1 : TPopupMenu;
    Cut2 : TMenuItem; 
    Copy2 : TMenuItem;
    Paste2 : TMenuItem;
    SaveFileDialog : TSaveDialog;
    FontDialog1 : TFontDialog;
    Close1 : TMenuItem;
    Test1 : TMenuItem;
    LinearSrtItem: TMenuItem;
    ClrOutput : TMenuItem;
    BreadthSrtItem: TMenuItem;
    ModifLinearSrtItem: TMenuItem;
    Quant1 : TMenuItem; 
    N1 : TMenuItem;
    Checkby1 : TMenuItem; 
    Checkby2 : TMenuItem;
    Redcheck1 : TMenuItem;
    Output1 : TMenuItem;
    Unifiers1 : TMenuItem; 
    Exiton1 : TMenuItem; 
    Exiton2 : TMenuItem;
    N4 : TMenuItem; 
    N5 : TMenuItem;
    Without1 : TMenuItem;
    Filtra1 : TMenuItem;
    Support1 : TMenuItem;
    N6 : TMenuItem; 
    Oneref1 : TMenuItem;
    Allref1 : TMenuItem;
    Axioms : TMenuItem;
    Progress : TMenuItem;
    N7 : TMenuItem;
    Stop1 : TMenuItem;
    Sources : TMenuItem;
    Resolvents : TMenuItem;
    Time : TMenuItem;
    Memory1 : TMenuItem;
    Unsim : TMenuItem; 
    Stat : TMenuItem;
    Font1 : TMenuItem;
    Exiton3: TMenuItem;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    LinearSrtButton: TSpeedButton;
    BreadthSrtButton: TSpeedButton;
    ModifLinearSrtButton: TSpeedButton;
    General: TMenuItem;
    SRcheck1: TMenuItem;
    SRLimit: TMenuItem;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Interactive: TMenuItem;
    Editor: TMemo;
    Output: TMemo;
    ButtonNeg: TButton;
    ButtonAll: TButton;
    ButtonEx: TButton;
    ButtonImp: TButton;
    ButtonAnd: TButton;
    ButtonOr: TButton;
    ButtonNeqv: TButton;
    ButtonLeqv: TButton;
    ButtonGeqv: TButton;
    ButtonSep: TButton;
    procedure Exit1Click(Sender : TObject); 
    procedure New1Click(Sender : TObject);
    procedure Cut1Click(Sender : TObject); 
    procedure Copy1Click(Sender : TObject);
    procedure Paste1Click(Sender : TObject);
    procedure Selectall1Click(Sender : TObject);
    procedure Delete1Click(Sender : TObject); 
    procedure Edit1Click(Sender : TObject);
    procedure Saveas1Click(Sender : TObject);
    procedure Save1Click(Sender : TObject);
    procedure Font1Click(Sender : TObject);
    procedure Close1Click(Sender : TObject);
    procedure FormClose(Sender : TObject; var Action : TCloseAction);
    procedure FormCloseQuery(Sender : TObject; var CanClose : Boolean);
    procedure FormCreate(Sender : TObject);
    procedure Open1Click(Sender : TObject); 
    procedure ProveClick(Sender : TObject);
    procedure EditorKeyPress(Sender : TObject; var Key : Char);
    procedure ClrOutputClick(Sender : TObject);
    procedure FormDestroy(Sender : TObject);
    procedure Redcheck1Click(Sender : TObject);
    procedure Without1Click(Sender : TObject);
    procedure Exiton1Click(Sender : TObject);
    procedure Quant1Click(Sender : TObject);
    procedure Allref1Click(Sender : TObject); 
    procedure Stop1Click(Sender : TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SRcheck1Click(Sender: TObject);
    procedure SRLimitClick(Sender: TObject);
    procedure InteractiveClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EditorKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButtonNegClick(Sender: TObject);
  private
    { Private declarations }
    PathName : string;

    Cont : string;
    OutputBuffer : TStringList;
  public
    Prog : TPLProgram;
    { Public declarations }
    procedure Open(const AFileName : string); 
      { Makes a link to current contents of the editor. }
    function ContAddr : PChar; 
  end;

var
  EditForm : TEditForm;
const
  DefaultFileName = 'Untitled';

implementation

uses Clipbrd, Printers, MDIFrame;

{$R *.DFM}

function TEditForm.ContAddr; 
begin
  Result := PChar(Cont);
end;

procedure TEditForm.Exit1Click(Sender : TObject);
begin
  FrameForm.Exit1Click(Sender); 
end;

procedure TEditForm.New1Click(Sender : TObject); 
begin
  FrameForm.New1Click(Sender);
end; 

procedure TEditForm.Open1Click(Sender : TObject); 
begin
  FrameForm.Open1Click(Sender); 
end; 

procedure TEditForm.Cut1Click(Sender : TObject); 
begin
  if Output.Focused then Output.CutToClipboard
  else if Editor.Focused then Editor.CutToClipboard; 
end;

procedure TEditForm.Copy1Click(Sender : TObject);
begin
  if Output.Focused then Output.CopyToClipboard
  else if Editor.Focused then Editor.CopyToClipboard;
end;

procedure TEditForm.Paste1Click(Sender : TObject);
begin
  if Output.Focused then Output.PasteFromClipboard
  else if Editor.Focused then Editor.PasteFromClipboard;
end; 

procedure TEditForm.Selectall1Click(Sender : TObject);
begin
  if Output.Focused then Output.SelectAll
  else if Editor.Focused then Editor.SelectAll; 
end; 

procedure TEditForm.Delete1Click(Sender : TObject); 
begin
  if Output.Focused then Output.ClearSelection
  else if Editor.Focused then Editor.ClearSelection; 
end; 

procedure TEditForm.Edit1Click(Sender : TObject); 
var
  HasSelection : Boolean;
begin
  if Editor.Focused then
  begin
    Paste1.Enabled := Clipboard.HasFormat(CF_TEXT);
    Paste2.Enabled := Paste1.Enabled; 
    HasSelection := Editor.SelLength > 0; 
    Cut1.Enabled := HasSelection;
    Cut2.Enabled := HasSelection; 
    Copy1.Enabled := HasSelection;
    Copy2.Enabled := HasSelection;
    Delete1.Enabled := HasSelection;
  end
  else
  if Output.Focused then
  begin
    Paste1.Enabled := Clipboard.HasFormat(CF_TEXT); 
    Paste2.Enabled := Paste1.Enabled; 
    HasSelection := Output.SelLength > 0;
    Cut1.Enabled := HasSelection; 
    Cut2.Enabled := HasSelection;
    Copy1.Enabled := HasSelection;
    Copy2.Enabled := HasSelection;
    Delete1.Enabled := HasSelection; 
  end;
end; 

procedure TEditForm.Open(const AFileName : string);
begin
  PathName := AFileName;
  Caption := ExtractFileName(AFileName);
  with Editor do
  begin
    Lines.LoadFromFile(PathName);
    SelStart := 0;
    Modified := False;
  end;
end;

procedure TEditForm.Saveas1Click(Sender : TObject);
begin
  SaveFileDialog.FileName := PathName;
  if SaveFileDialog.Execute then
  begin
    PathName := SaveFileDialog.FileName;
    Caption := ExtractFileName(PathName);
    Save1Click(Sender);
  end; 
end;

procedure TEditForm.Save1Click(Sender : TObject); 
begin
  if PathName = DefaultFileName then
    SaveAs1Click(Sender)
  else
  begin
    Editor.Lines.SaveToFile(PathName); 
    Editor.Modified := False;
  end;
end; 

procedure TEditForm.Font1Click(Sender : TObject);
begin
  if Editor.Focused then
  begin
    FontDialog1.Font := Editor.Font; 
    if FontDialog1.Execute then
    begin
      Editor.Font.Assign(FontDialog1.Font);
    end;
    end
  else if Output.Focused then
  begin
    FontDialog1.Font := Output.Font; 
    if FontDialog1.Execute then
    begin
      Output.Font.Assign(FontDialog1.Font); 
    end; 
  end
end; 

procedure TEditForm.Close1Click(Sender : TObject); 
begin
  Close;
end;

procedure TEditForm.FormClose(Sender : TObject; var Action : TCloseAction); 
begin
  Action := caFree;
end; 

procedure TEditForm.FormCloseQuery(Sender : TObject; var CanClose : Boolean);
const
  SWarningText = 'Save changes to %s?'; 
begin
  if Editor.Modified then
  begin
    case MessageDlg(Format(SWarningText, [PathName]), mtConfirmation, 
      [mbYes, mbNo, mbCancel], 0) of
      idYes : Save1Click(Self);
      idCancel : CanClose := False;
    end;
  end;
end;

procedure TEditForm.FormCreate(Sender : TObject); 
begin
  PathName := DefaultFileName;
  Prog := TPLProgram.Create;
  CurProg := Prog;
  Cont := PChar(Editor.Text);
  Editor.Font.Name := 'Frame Logic';
  Editor.Font.Size := 11;
  //Editor.Font.Style := [fsBold];
  Output.Font.Name := 'Frame Logic';
  Output.Font.Size := 11;
  //Output.Font.Style := [fsBold];


end;

{******************************************}


procedure TEditForm.ProveClick(Sender : TObject);
begin
   if (Sender = LinearSrtButton)or(Sender = LinearSrtItem) then
     Prog.Strategy := SrtLinear
   else if (Sender = BreadthSrtButton)or(Sender = BreadthSrtItem) then
     Prog.Strategy := SrtBreadth
   else if (Sender = ModifLinearSrtButton)or(Sender = ModifLinearSrtItem) then
     Prog.Strategy := SrtModifLinear;

   //assign properties from GUI

   Prog.Interactive := Interactive.Checked;
   Prog.Time := Time.Checked;
   Prog.Memory1 := Memory1.Checked;
   Prog.Axioms := Axioms.Checked;
   Prog.Resolvents := Resolvents.Checked;
   Prog.Stat := Stat.Checked;
   Prog.Checkby1 := Checkby1.Checked;
   Prog.Checkby2 := Checkby2.Checked;
   Prog.Without1 := Without1.Checked;
   Prog.Support1 := Support1.Checked;
   Prog.Filtra1 := Filtra1.Checked;
   Prog.Unsim := Unsim.Checked;
   Prog.Progress := Progress.Checked;
   Prog.Sources := Sources.Checked;
   Prog.ExitOn1 := ExitOn1.Checked;
   Prog.ExitOn3 := ExitOn3.Checked;
   Prog.SrCheck1 := SrCheck1.Checked;
   Prog.General := General.Checked;
   Prog.RedCheck1 := RedCheck1.Checked;
   Prog.OneRef1 := OneRef1.Checked;
   Prog.Quant1 := Quant1.Checked;

   Output.Clear;
   
   OutPutBuffer := TStringList.Create;
   if Prog.Interactive then Prog.OutPutLines := @Output.Lines
   else Prog.OutPutLines := @OutputBuffer;
   Prog.InputContent := PChar(Editor.Text);

   Prog.stopf := false;
   Prog.Generate;

   if (Prog.Err = OK)and(Prog.Interactive=false) then
   begin
     Prog.OutputLines.SaveToFile(PathName+'.out');
   end;

   Output.SetFocus;
   if Prog.OutputLines <> @Output.Lines then
   begin
     If Length(Prog.OutputLines.Text)>32767 then
     begin
       Output.Lines.Add('Done, but output text exceeded the maximal size / consult the output file (*.out).');
       Output.selStart := Length(Output.text) - 1;
     end
     else
     begin
       Output.Lines.Add(Prog.OutputLines^.Text);
       Output.selStart := Length(Output.text) - 1;
     end;
   end;
   case Prog.Err of
    illchar : ShowMessage('Illegal character.');
    missoper : ShowMessage('Missing operator.');
    missbra : ShowMessage('Missing right bracket.');
    missexp : ShowMessage('Missing expression.');
    unexpbra : ShowMessage('Unexpected right bracket.');
    mem : ShowMessage('Insuficient memory.');
    missdelim : ShowMessage('Missing Delimiter.');
    wrongmol : ShowMessage('Wrong atom expression.');
    invrealval : ShowMessage('Invalid real expression.');
    invintval : ShowMessage('Invalid integer expression.');
    invidterm : ShowMessage('Invalid IDTerm.');
    invvar : ShowMessage('Invalid variable expression.');
    wrongDegExp : ShowMessage('Wrong evaluation degree expression.');
   end;
   if Prog.InputErrorPos <> 0 then
   begin
     Editor.SelStart := Prog.InputErrorPos;
     Editor.SetFocus;
   end;

   if Prog.stopf then
   begin
     Prog.Free;
     Prog := TPLProgram.Create;
     CurProg := Prog;
     Prog.stopf := false;
   end;

   OutPutBuffer.Free;
end;

var Done : boolean = false; Scanned : boolean = false;

{ Special handler for logical characters, suppress national keyboard
  layout support.                                                    }

procedure TEditForm.EditorKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var k1 : Word; c1 : char;
begin
  k1 := Key; Done := false; Scanned := true;
  if Shift = [ssCtrl, ssAlt] then
  begin
    Key := 0; Done := true; Scanned := true;



    case k1 of
      ord('Q') : TRichEdit(Sender).SelText := cforall;
      ord('W') : TRichEdit(Sender).SelText := cexists;
      ord('C') : TRichEdit(Sender).SelText := cand;
      ord('D') : TRichEdit(Sender).SelText := cor;
      ord('I') : TRichEdit(Sender).SelText := cimp;
      //ord('E') : TRichEdit(Sender).SelText := ceqv;
      ord('G') : TRichEdit(Sender).SelText := cgeqv;
      ord('F') : TRichEdit(Sender).SelText := cneqv;
      VK_SPACE : TRichEdit(Sender).SelText := cFmlSep+' ';
      ord('N') : TRichEdit(Sender).SelText := cneg;
      ord('L') : TRichEdit(Sender).SelText := cleqv;
    else Key := k1; Done := false;
    end;
  end;
  {if Shift = [ssCtrl, ssAlt, ssShift] then
  begin
    Key := 0; Done := true; Scanned := true;
    case k1 of
      ord('C') : TRichEdit(Sender).SelText := cordand;
      ord('D') : TRichEdit(Sender).SelText := cordor;
    else Key := k1; Done := false;
    end;
  end;}
  begin
  if Shift = [] then
  begin
    Key := 0; Done := true; Scanned := true;
    case k1 of
      ord('1') : TRichEdit(Sender).SelText := '1';
      ord('2') : TRichEdit(Sender).SelText := '2';
      ord('3') : TRichEdit(Sender).SelText := '3';
      ord('4') : TRichEdit(Sender).SelText := '4';
      ord('5') : TRichEdit(Sender).SelText := '5';
      ord('6') : TRichEdit(Sender).SelText := '6';
      ord('7') : TRichEdit(Sender).SelText := '7';
      ord('8') : TRichEdit(Sender).SelText := '8';
      ord('9') : TRichEdit(Sender).SelText := '9';
      ord('0') : TRichEdit(Sender).SelText := '0';
      $c0 : TRichEdit(Sender).SelText := '`';
      $bd : TRichEdit(Sender).SelText := '-';
      $bb : TRichEdit(Sender).SelText := '=';
      $db : TRichEdit(Sender).SelText := '[';
      $dd : TRichEdit(Sender).SelText := ']';
      $dc : TRichEdit(Sender).SelText := '\';
      $ba : TRichEdit(Sender).SelText := ';';
      $de : TRichEdit(Sender).SelText := '''';
      $bc : TRichEdit(Sender).SelText := ',';
      $be : TRichEdit(Sender).SelText := '.';
      $bf : TRichEdit(Sender).SelText := '/';
    else Key := k1; Done := false;
    end;
  end;
  if (Shift = [ssShift]) then
  begin
    Key := 0; Done := true; Scanned := true;
    case k1 of
      ord('1') : TRichEdit(Sender).SelText := '!';
      ord('2') : TRichEdit(Sender).SelText := '@';
      ord('3') : TRichEdit(Sender).SelText := '#';
      ord('4') : TRichEdit(Sender).SelText := '$';
      ord('5') : TRichEdit(Sender).SelText := '%';
      ord('6') : TRichEdit(Sender).SelText := '^';
      ord('7') : TRichEdit(Sender).SelText := '&';
      ord('8') : TRichEdit(Sender).SelText := '*';
      ord('9') : TRichEdit(Sender).SelText := '(';
      ord('0') : TRichEdit(Sender).SelText := ')';
      $c0 : TRichEdit(Sender).SelText := '~';
      $bd : TRichEdit(Sender).SelText := '_';
      $bb : TRichEdit(Sender).SelText := '+';
      $db : TRichEdit(Sender).SelText := '{';
      $dd : TRichEdit(Sender).SelText := '}';
      $dc : TRichEdit(Sender).SelText := '|';
      $ba : TRichEdit(Sender).SelText := ':';
      $de : TRichEdit(Sender).SelText := '"'; 
      $bc : TRichEdit(Sender).SelText := '<'; 
      $be : TRichEdit(Sender).SelText := '>';
      $bf : TRichEdit(Sender).SelText := '?';
    else Key := k1; Done := false; 
    end;
  end;
  if (Key >= ord('A')) and (Key <= ord('Z'))
      and((shift = [])or(shift = [ssshift])) then
    begin
      Key := 0; Done := true; Scanned := true;
      case k1 of
      ord('A') : c1 := 'a';
      ord('B') : c1 := 'b';
      ord('C') : c1 := 'c';
      ord('D') : c1 := 'd';
      ord('E') : c1 := 'e';
      ord('F') : c1 := 'f';
      ord('G') : c1 := 'g';
      ord('H') : c1 := 'h';
      ord('I') : c1 := 'i';
      ord('J') : c1 := 'j';
      ord('K') : c1 := 'k'; 
      ord('L') : c1 := 'l'; 
      ord('M') : c1 := 'm';
      ord('N') : c1 := 'n';
      ord('O') : c1 := 'o';
      ord('P') : c1 := 'p';
      ord('Q') : c1 := 'q';
      ord('R') : c1 := 'r';
      ord('S') : c1 := 's';
      ord('T') : c1 := 't';
      ord('U') : c1 := 'u';
      ord('V') : c1 := 'v';
      ord('W') : c1 := 'w';
      ord('X') : c1 := 'x';
      ord('Y') : c1 := 'y';
      ord('Z') : c1 := 'z';
      end;
      if (GetKeyState(VK_CAPITAL) = 1) <> (Shift = [ssShift]) then
         c1 := chr(ord(c1)-32);
      TRichEdit(Sender).SelText := c1;
      Key := 0; Done := true;
    end;
  end;
end;

procedure TEditForm.EditorKeyPress(Sender : TObject; var Key : Char);
begin
  if (Done)or(not(scanned))or(key > #127) then
  begin
    key := #0;
    Done := false; Scanned := false;
  end;
end;

procedure TEditForm.ClrOutputClick(Sender : TObject);
begin
  Output.Clear;
end;

procedure TEditForm.FormDestroy(Sender : TObject);
begin
  Prog.Free;
end;

procedure TEditForm.Redcheck1Click(Sender : TObject);
begin
  RedCheck1.Checked := false;
  Checkby1.Checked := false;
  Checkby2.Checked := false;
  (Sender as TMenuItem).Checked := true;
end;

procedure TEditForm.Without1Click(Sender : TObject);
begin
  Without1.Checked := false;
  Filtra1.Checked := false;
  Support1.Checked := false;
  (Sender as TMenuItem).Checked := true;
end; 

procedure TEditForm.Exiton1Click(Sender : TObject);
begin
  ExitOn1.Checked := false;
  ExitOn2.Checked := false;
  ExitOn3.Checked := false;
  (Sender as TMenuItem).Checked := true;
end;

procedure TEditForm.Quant1Click(Sender : TObject);
begin
  (Sender as TMenuItem).Checked := not((Sender as TMenuItem).Checked);
end;

procedure TEditForm.Allref1Click(Sender : TObject);
begin
  Oneref1.Checked := false; 
  Allref1.Checked := false; 
  (Sender as TMenuItem).Checked := true;
end; 

procedure TEditForm.Stop1Click(Sender : TObject);
begin
  Prog.stopf := true;
end;

procedure TEditForm.SpeedButton1Click(Sender: TObject);
begin
  Prog.stopf := true;
end;



procedure TEditForm.SRcheck1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not((Sender as TMenuItem).Checked);
end;

procedure TEditForm.SRLimitClick(Sender: TObject);
begin
  Prog.DCF := StrToInt(InputBox('Detection of consequent formulas limit','Maximal number of iterations:','5'));
  if Prog.DCF < 1 then Prog.DCF := 1;
end;

procedure TEditForm.InteractiveClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not((Sender as TMenuItem).Checked);
end;

procedure TEditForm.FormActivate(Sender: TObject);
begin
  CurProg := Prog;
  Editor.SetFocus;
end;

procedure TEditForm.ButtonNegClick(Sender: TObject);
begin
  if Sender = ButtonNeg then Editor.SelText := cneg else
  if Sender = ButtonAll then Editor.SelText := cforall else
  if Sender = ButtonEx then Editor.SelText := cexists else
  if Sender = ButtonImp then Editor.SelText := cimp else
  if Sender = ButtonOr then Editor.SelText := cor else
  if Sender = ButtonAnd then Editor.SelText := cand else
  if Sender = ButtonNeqv then Editor.SelText := cneqv else
  if Sender = ButtonLeqv then Editor.SelText := cleqv else
  if Sender = ButtonGeqv then Editor.SelText := cgeqv else
  if Sender = ButtonSep then Editor.SelText := cFmlSep+' ';
end;



begin
DecimalSeparator := '.';











end.
